typedef int Int;
#define fmtInt	"%i"

// Vs-Type
#define VST_NUL		0
#define VST_INT		1
#define VST_FLT		2
#define VST_STR		3
#define VST_PTR		4	// Vw|C^Ȃ.

typedef struct VS_ {
	char typ, typPad[3];
	union {
		struct { void *p; union { int len; Int id; }; };
		Int i;
		double f;
	};
} VS; // 12-16bytes.

typedef struct V_ {
	VS dat, nam, tag, src;
	int flg, nc;
	Int id;
	struct V_ *parent, *prv, *nxt;
} V;

typedef struct CW_ {
	V *root;
	V vPool, dummyV;
	Int idNext;
	int memAlcV, memMlc, memByt;
} CW;

typedef struct W_ {
	CW *cw;
	V *pwd, *dstTxt, *dstTmp, *pscd;
	int nc1;
	char *ncStk;
} W;

// vs.c
void iniVs(VS *vs);
void vsNul(W *w, VS *vs);
void vsInt(W *w, VS *vs, Int i);
void vsFlt(W *w, VS *vs, double f);
void vsStr(W *w, VS *vs, const char *s, int l);
void vsStrAscz(W *w, VS *vs, const char *s);
void vsPtr(W *w, VS *vs, V *v);

#if 0

#define FLG_WP		8



// essen0.c
void *my_malloc(W *w, int siz);
void my_free(W *w, void *p, int siz);
void iniCW(CW *cw);
void iniW(W *w, CW *cw);

// essen1.c
void essen1_init(W *w);
int o_semicolon(W *w, V *v, int m);
int o_dmp(W *w, V *v, int m);
int o_exit(W *w, V *v, int m);
int o_plus2flt(W *w, V *v, int m);
int o_minus2(W *w, V *v, int m);
int o_mul(W *w, V *v, int m);
int o_div(W *w, V *v, int m);
int o_cmpEq(W *w, V *v, int m);
int o_cmpNe(W *w, V *v, int m);
int o_cmpG(W *w, V *v, int m);
int o_cmpGe(W *w, V *v, int m);
int o_cmpL(W *w, V *v, int m);
int o_cmpLe(W *w, V *v, int m);
int o_plus1(W *w, V *v, int m);
int o_minus1(W *w, V *v, int m);
int o_plus2str(W *w, V *v, int m);
int o_plus2dir(W *w, V *v, int m);
int o_minus2dir(W *w, V *v, int m);
V *alcNulAddTxt(W *w, V *v0, int nc);
void alcFltAddTxt(W *w, double d, V *v0, int nc);
void alcBolAddTxt(W *w, int b, V *v0, int nc);
void rfV3(W *w, V *v);
void AddOpr(W *w, V *s, void *f, char *fn);
V *defOpr(W *w, char *n, void *f, char *fn);

// v.c
void iniV(V *v);
V *alcV(W *w);
void freV(W *w, V *v);
void freV1(W *w, V *s);
void rmvV(V *v);
void addV(V *v, V *s);
V *alcDst(W *w);
void setId(W *w, V *v);
void addMmb(W *w, V *v, V *p, V *s);
void addEot(W *w);
void dumpV(V *v, char verbose, void *hw);
V *schV(W *w, VS *t, V *scd, int lv);

// vs.c
void iniVs(VS *vs);
void vsNul(W *w, VS *vs);
void vsInt(W *w, VS *vs, Int i);
void vsFlt(W *w, VS *vs, double f);
void vsStr(W *w, VS *vs, const char *s, int l);
void vsStrAscz(W *w, VS *vs, const char *s);
void vsPtr(W *w, VS *vs, V *v);
void vsDir(W *w, VS *vs, V *dst);
void vsDst(W *w, VS *vs);
void vsScd(W *w, VS *vs, V *v, int lv);
void vsBol(W *w, VS *vs, Int i);
void vsTxt(W *w, VS *vs);
void vsIcb(W *w, VS *vs);
void vsUkt(W *w, VS *vs);
void vsEot(W *w, VS *vs);
void vsFnd(W *w, VS *vs, V *dst);
void vsFnp(W *w, VS *vs, V *dst);
void vsFnc(W *w, VS *vs, ...);
void vsFnb(W *w, VS *vs, void *f);
void vsOpd(W *w, VS *vs, V *dst);
void vsOpp(W *w, VS *vs, V *dst);
void vsOpr(W *w, VS *vs, ...);
void vsOpb(W *w, VS *vs, void *f);
void freVs(W *w, VS *vs, char typ);

// lib.c
void el_printf(void *hw, const char *fmt,...);
void el_puts(void *hw, const unsigned char *s);

// drv.c
void ed_putc(void *hw, unsigned char c);

#endif

