#include "kcl.h"
#include <stdlib.h>

void KCL_Malloc_init(KCL_Malloc *mpool)
{
	KCL_PtrPool_init(&(mpool->pool0008),    8, 65536 /    8, 4);	// 25%.
	KCL_PtrPool_init(&(mpool->pool0016),   16, 65536 /   16, 4);
	KCL_PtrPool_init(&(mpool->pool0064),   64, 65536 /   64, 4);
//	KCL_PtrPool_init(&(mpool->pool0256),  256, 65536 /  256, 4);
//	KCL_PtrPool_init(&(mpool->pool1024), 1024, 65536 / 1024, 4);
//	KCL_PtrPool_init(&(mpool->pool4096), 4096, 65536 / 4096, 4);
	return;
}

void KCL_Malloc_free(KCL_Malloc *mpool)
{
	KCL_PtrPool_free(&(mpool->pool0008));
	KCL_PtrPool_free(&(mpool->pool0016));
	KCL_PtrPool_free(&(mpool->pool0064));
//	KCL_PtrPool_free(&(mpool->pool0256));
//	KCL_PtrPool_free(&(mpool->pool1024));
//	KCL_PtrPool_free(&(mpool->pool4096));
	return;
}

static int sizAdjust(int siz)
{
	if (   0 < siz && siz <=    8) siz =    8;
	if (   8 < siz && siz <=   16) siz =   16;
	if (  16 < siz && siz <=   64) siz =   64;
	return siz;
}

KCL_Obj KCL_Malloc_alc(KCL_Malloc *mpool, int siz)
{
	KCL_Obj p = NULL;
	siz = sizAdjust(siz);
	if (siz ==   8)
		p = KCL_PtrPool_pull(&(mpool->pool0008));
	if (siz ==  16)
		p = KCL_PtrPool_pull(&(mpool->pool0016));
	if (siz ==  64)
		p = KCL_PtrPool_pull(&(mpool->pool0064));
	if (siz > 64)
		p = malloc(siz);
	return p;
}

void KCL_Malloc_fre(KCL_Malloc *mpool, KCL_Obj obj, int siz)
{
	siz = sizAdjust(siz);
	if (siz ==   8)
		KCL_PtrPool_push(&(mpool->pool0008), obj);
	if (siz ==  16)
		KCL_PtrPool_push(&(mpool->pool0016), obj);
	if (siz ==  64)
		KCL_PtrPool_push(&(mpool->pool0064), obj);
	if (siz > 64)
		free(obj);
	return;
}


