#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "essen.h"
#include "kcl.h"

#define FRE(typ)	freVs(w, vs, typ)

void freVs(W *w, VS *vs, char typ)
{
	char ot = vs->typ;
	if (ot == VST_STR)
		my_free(w, vs->p, vs->len);
	vs->typ = typ;
}

void iniVs(VS *vs)
{
	vs->typ = VST_NUL;
}

void vsNul(W *w, VS *vs)
{
	FRE(VST_NUL);
}

void vsInt(W *w, VS *vs, Int i)
{
	FRE(VST_INT);
	vs->i = i;
}

void vsFlt(W *w, VS *vs, double f)
{
	FRE(VST_FLT);
	vs->f = f;
}

void vsStr(W *w, VS *vs, const char *s, int l)
{
	FRE(VST_STR);
	vs->p = my_malloc(w, l);
	vs->len = l;
	memcpy(vs->p, s, l);
}

void vsStrAscz(W *w, VS *vs, const char *s)
{
	vsStr(w, vs, s, strlen(s));
}

void vsPtr(W *w, VS *vs, V *v)
{
	FRE(VST_PTR);
	vs->p = &w->cw->dummyV;
	vs->id = 0;
	if (v != NULL) {
		vs->p = v;
		vs->id = v->id;
	}
}


// cpyVs


